    <!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="generator" content="ExDoc v0.15.1">
    <title>BachelorThesis.Endpoint – bachelor_thesis v0.0.1</title>
    <link rel="stylesheet" href="dist/app-af302bfcc4.css" />
    
    <script src="dist/sidebar_items-1963507629.js"></script>
  </head>
  <body data-type="modules">
    <script>try { if(localStorage.getItem('night-mode')) document.body.className += ' night-mode'; } catch (e) { }</script>

    <div class="main">
<button class="sidebar-toggle">
  <i class="icon-menu"></i>
</button>
<section class="sidebar">

  
  <a href="api-reference.html" class="sidebar-projectLink">
    <div class="sidebar-projectDetails">
      <h1 class="sidebar-projectName">
        bachelor_thesis
      </h1>
      <h2 class="sidebar-projectVersion">
        v0.0.1
      </h2>
    </div>
    
  </a>

  <div class="sidebar-search">
    <i class="icon-search"></i>
    <input type="text" class="sidebar-searchInput" placeholder="search" autocomplete="off" />
  </div>

  <ul class="sidebar-listNav">
    <li><a id="extras-list" href="#full-list">Pages</a></li>

    
      <li><a id="modules-list" href="#full-list">Modules</a></li>
    

    

    
  </ul>
  <div class="gradient"></div>
  <ul id="full-list" class="sidebar-fullList"></ul>
</section>

<section class="content">
  <div class="content-outer">
    <div id="content" class="content-inner">


      <h1>
        <small class="visible-xs">bachelor_thesis v0.0.1</small>
        BachelorThesis.Endpoint
        
        
      </h1>

      

      
        <section id="summary" class="details-list">
          <h1 class="section-heading">
            <a class="hover-link" href="#summary">
              <i class="icon-link"></i>
            </a>
            Summary
          </h1>
          

          
  <div class="summary-functions summary">
    <h2>
      <a href="#functions">Functions</a>
    </h2>
    <div class="summary-row">
  <div class="summary-signature">
    <a href="#__sockets__/0">__sockets__()</a>
  </div>
  
    <div class="summary-synopsis"><p>Returns all sockets configured in this endpoint</p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#broadcast/3">broadcast(topic, event, msg)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#broadcast!/3">broadcast!(topic, event, msg)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#broadcast_from/4">broadcast_from(from, topic, event, msg)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#broadcast_from!/4">broadcast_from!(from, topic, event, msg)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#call/2">call(conn, opts)</a>
  </div>
  
    <div class="summary-synopsis"><p>Callback implementation for <a href="https://hexdocs.pm/plug/1.3.4/Plug.html#c:call/2"><code class="inline">Plug.call/2</code></a></p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#config/2">config(key, default \\ nil)</a>
  </div>
  
    <div class="summary-synopsis"><p>Returns the endpoint configuration for <code class="inline">key</code></p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#config_change/2">config_change(changed, removed)</a>
  </div>
  
    <div class="summary-synopsis"><p>Reloads the configuration given the application environment changes</p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#init/1">init(opts)</a>
  </div>
  
    <div class="summary-synopsis"><p>Callback implementation for <a href="https://hexdocs.pm/plug/1.3.4/Plug.html#c:init/1"><code class="inline">Plug.init/1</code></a></p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#instrument/3">instrument(event, runtime \\ Macro.escape(%{}), fun)</a>
  </div>
  
    <div class="summary-synopsis"><p>Instruments the given function</p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#path/1">path(path)</a>
  </div>
  
    <div class="summary-synopsis"><p>Generates the path information when routing to this endpoint</p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#start_link/0">start_link()</a>
  </div>
  
    <div class="summary-synopsis"><p>Starts the endpoint supervision tree</p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#static_path/1">static_path(path)</a>
  </div>
  
    <div class="summary-synopsis"><p>Generates a route to a static file in <code class="inline">priv/static</code></p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#static_url/0">static_url()</a>
  </div>
  
    <div class="summary-synopsis"><p>Generates the static URL without any path information</p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#struct_url/0">struct_url()</a>
  </div>
  
    <div class="summary-synopsis"><p>Generates the endpoint base URL but as a <a href="https://hexdocs.pm/elixir/URI.html"><code class="inline">URI</code></a> struct</p>
</div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#subscribe/1">subscribe(topic)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#subscribe/2">subscribe(pid, topic)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#subscribe/3">subscribe(pid, topic, opts)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#unsubscribe/1">unsubscribe(topic)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#unsubscribe/2">unsubscribe(pid, topic)</a>
  </div>
  
</div>
<div class="summary-row">
  <div class="summary-signature">
    <a href="#url/0">url()</a>
  </div>
  
    <div class="summary-synopsis"><p>Generates the endpoint base URL without any path information</p>
</div>
  
</div>

  </div>


          

        </section>
      

      

      
        <section id="functions" class="details-list">
          <h1 class="section-heading">
            <a class="hover-link" href="#functions">
              <i class="icon-link"></i>
            </a>
            Functions
          </h1>
          <div class="detail" id="__sockets__/0">
  
  <div class="detail-header">
    <a href="#__sockets__/0" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">__sockets__()</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Returns all sockets configured in this endpoint.</p>

  </section>
</div>
<div class="detail" id="broadcast/3">
  
  <div class="detail-header">
    <a href="#broadcast/3" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">broadcast(topic, event, msg)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="broadcast!/3">
  
  <div class="detail-header">
    <a href="#broadcast!/3" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">broadcast!(topic, event, msg)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="broadcast_from/4">
  
  <div class="detail-header">
    <a href="#broadcast_from/4" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">broadcast_from(from, topic, event, msg)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="broadcast_from!/4">
  
  <div class="detail-header">
    <a href="#broadcast_from!/4" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">broadcast_from!(from, topic, event, msg)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="call/2">
  
  <div class="detail-header">
    <a href="#call/2" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">call(conn, opts)</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Callback implementation for <a href="https://hexdocs.pm/plug/1.3.4/Plug.html#c:call/2"><code class="inline">Plug.call/2</code></a>.</p>

  </section>
</div>
<div class="detail" id="config/2">
  
    <span id="config/1" />
  
  <div class="detail-header">
    <a href="#config/2" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">config(key, default \\ nil)</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Returns the endpoint configuration for <code class="inline">key</code></p>
<p>Returns <code class="inline">default</code> if the key does not exist.</p>

  </section>
</div>
<div class="detail" id="config_change/2">
  
  <div class="detail-header">
    <a href="#config_change/2" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">config_change(changed, removed)</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Reloads the configuration given the application environment changes.</p>

  </section>
</div>
<div class="detail" id="init/1">
  
  <div class="detail-header">
    <a href="#init/1" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">init(opts)</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Callback implementation for <a href="https://hexdocs.pm/plug/1.3.4/Plug.html#c:init/1"><code class="inline">Plug.init/1</code></a>.</p>

  </section>
</div>
<div class="detail" id="instrument/3">
  
    <span id="instrument/2" />
  
  <div class="detail-header">
    <a href="#instrument/3" class="detail-link" title="Link to this macro">
      <i class="icon-link"></i>
    </a>
    <span class="signature">instrument(event, runtime \\ Macro.escape(%{}), fun)</span>
    
    
      <span class="note">(macro)</span>
    
    
  </div>
  <section class="docstring">
    <p>Instruments the given function.</p>
<p><code class="inline">event</code> is the event identifier (usually an atom) that specifies which
instrumenting function to call in the instrumenter modules. <code class="inline">runtime</code> is
metadata to be associated with the event at runtime (e.g., the query being
issued if the event to instrument is a DB query).</p>
<h2 id="instrument/3-examples" class="section-heading">
  <a href="#instrument/3-examples" class="hover-link"><i class="icon-link"></i></a>
  Examples
</h2>

<pre><code class="elixir">instrument :render_view, %{view: &quot;index.html&quot;}, fn -&gt;
  render conn, &quot;index.html&quot;
end</code></pre>

  </section>
</div>
<div class="detail" id="path/1">
  
  <div class="detail-header">
    <a href="#path/1" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">path(path)</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Generates the path information when routing to this endpoint.</p>

  </section>
</div>
<div class="detail" id="start_link/0">
  
  <div class="detail-header">
    <a href="#start_link/0" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">start_link()</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Starts the endpoint supervision tree.</p>

  </section>
</div>
<div class="detail" id="static_path/1">
  
  <div class="detail-header">
    <a href="#static_path/1" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">static_path(path)</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Generates a route to a static file in <code class="inline">priv/static</code>.</p>

  </section>
</div>
<div class="detail" id="static_url/0">
  
  <div class="detail-header">
    <a href="#static_url/0" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">static_url()</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Generates the static URL without any path information.</p>
<p>It uses the configuration under <code class="inline">:static_url</code> to generate
such. It fallsback to <code class="inline">:url</code> if <code class="inline">:static_url</code> is not set.</p>

  </section>
</div>
<div class="detail" id="struct_url/0">
  
  <div class="detail-header">
    <a href="#struct_url/0" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">struct_url()</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Generates the endpoint base URL but as a <a href="https://hexdocs.pm/elixir/URI.html"><code class="inline">URI</code></a> struct.</p>
<p>It uses the configuration under <code class="inline">:url</code> to generate such.
Useful for manipulating the url data and passing to
URL helpers.</p>

  </section>
</div>
<div class="detail" id="subscribe/1">
  
  <div class="detail-header">
    <a href="#subscribe/1" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">subscribe(topic)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="subscribe/2">
  
  <div class="detail-header">
    <a href="#subscribe/2" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">subscribe(pid, topic)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="subscribe/3">
  
  <div class="detail-header">
    <a href="#subscribe/3" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">subscribe(pid, topic, opts)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="unsubscribe/1">
  
  <div class="detail-header">
    <a href="#unsubscribe/1" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">unsubscribe(topic)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="unsubscribe/2">
  
  <div class="detail-header">
    <a href="#unsubscribe/2" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">unsubscribe(pid, topic)</span>
    
    
    
  </div>
  <section class="docstring">
    
  </section>
</div>
<div class="detail" id="url/0">
  
  <div class="detail-header">
    <a href="#url/0" class="detail-link" title="Link to this function">
      <i class="icon-link"></i>
    </a>
    <span class="signature">url()</span>
    
    
    
  </div>
  <section class="docstring">
    <p>Generates the endpoint base URL without any path information.</p>
<p>It uses the configuration under <code class="inline">:url</code> to generate such.</p>

  </section>
</div>

        </section>
      

      
          <footer class="footer">
        <p>
          <span class="line">
            Built using
            <a href="https://github.com/elixir-lang/ex_doc" title="ExDoc" rel="help" target="_blank">ExDoc</a> (v0.15.1),
          </span>
          <span class="line">
            designed by
            <a href="https://twitter.com/dignifiedquire" target="_blank" title="@dignifiedquire">Friedel Ziegelmayer</a>.
            </span>
        </p>
        <button class="night-mode-toggle" />
      </footer>
    </div>
  </div>
</section>
</div>
  <script src="dist/app-e9767fa739.js"></script>
  </body>
</html>

